/*  Class  ParseHTML A subclass of the Visual dBASE 7.5 WebClass.cc, this
	   class implements using HTML files with embeded codes to display
           or edit table data.  The class can also be used to simply display
           html pages.

    Method:         DisplayHTML()

    Class:          ParseHTML
    File:           ParseHTML.cc

    Params:         (rowsetFields, cPageName)

    Purpose: read an html-formated file and return the page to the web browser.            
  
    Authors: Michael Nuwer, a dBASE user 
             Ed Hoskins from dBASE Inc.
         
             (06/28/2000)
*/

Class ParseHTML of CGISession from "WebClass.cc"

Function DisplayHTML(rowsetFields,cHTMLFile,cPageTitle)
   // To display an HTML file with no database fields, 
   // send rowsetFields as null
   rFields = rowsetFields
   if empty(cHTMLFile)
     this.SorryPage("No HTML document was requested",;
                    "Missing Document",;
                    "Please contact the web master") 
   else if not file(cHTMLFile)
     this.SorryPage("No HTML document found",;
                    cHTMLFile,;
                    "Please contact the web master")
   else

     with (this.fOut)
         puts('Content-type: text/html')
         puts('')
      endwith
      this.fOut.Puts("")
      oHTML = new file()
      oHTML.open(cHTMLFile)
      do while not oHTML.eof()
         cLine = oHTML.Gets()
         if rFields <> null
            if at("<#",cLine) > 0
              nPos = 1
              do while nPos <= len(cLine)
                if substr(cLine,nPos,2) = "<#"
                  // we're at the start of a code
                  StartPos = nPos
                  nPos = nPos + 2
                  cName = ""
                  do while substr(cLine,nPos,1) <> ">"
                    cName = cName + substr(cLine,nPos,1)
                    nPos = nPos + 1
                  enddo
                  EndPos = nPos
                  cValue = ""
                  if type("rFields[cName]") = "O"
                    with rFields[cName]
                      do case
                        case type="LOGICAL"
                          // Assume checkbox object
                          // You can also return html strings that
                          // refer to an image of a box for false
                          // and an image of a checkmark for true
                          cValue = iif(value,"Yes","No")
                        case type $ "BINARY,OLE"
                          // do nothing
                        // Add any special cases based on the type
                        // of tables you are using
                        otherwise
                        // generic auto-conversion
                          cValue = ""+value
                      endcase
                    endwith
                  else
                     // if the value is not a field in the table
                     // it should be in the CGI array as a value
                     // passed from the referring page
                     if this.iskey(cName)
                        cValue = this[cName]
                     endif
                  endif
                  cLine = Stuff(cLine,StartPos,EndPos-StartPos+1,;
                          trim(""+cValue))
                  nPos = StartPos+len(trim(""+cValue))                  
                else
                  nPos = nPos + 1
                endif
              enddo
            endif
         endif
         this.fOut.Puts(cLine)
      enddo
      oHTML.close()
      oHTML = null
   endif
return

endclass